<?php
// $Id: sm.drush.inc,v 1.1.2.3 2009/05/24 19:30:11 clemenstolboom Exp $

/**
 * @file
 *   The Drush System Manager
 */

/**
 * Implementation of hook_drush_help()
 *
 * @param unknown_type $path
 * @param unknown_type $arg
 * @return unknown
 */
function sm_drush_help($ection) {
  switch ($section) {
    case 'drush:sm list':
      return dt("Lists one of the given system aspects: " . _drush_sm_service_strings());
    case 'drush:sm export':
      return dt("Exports one of the given system aspects: " . _drush_sm_service_strings());
    case 'drush:sm import':
      return dt("Imports one of the given system aspects: " . _drush_sm_service_strings());
    case 'drush:sm report':
      return dt("Reports one of the given system aspects: " . _drush_sm_service_strings());
  }
}

/**
 * Implementation of hook_drush_command().
 */
function sm_drush_command() {
  return drush_sm_command_list($section);
}

function _drush_sm_services() {
  static $files;
  if (!isset($files)) {
    $includes = dirname(__FILE__) . '/inc/*.sm.inc';
    $files = glob($includes);
  }
  foreach ($files as $index => $file) {
    $files[$index] = str_replace('.sm.inc', '', basename($file));
  }
  return $files;
}

function _drush_sm_service_strings() {
  return '[' . implode( "|" , _drush_sm_services()) . ']';
}

function _drush_sm_command() {
  return array( 'list', 'export', 'report', 'import');
}

function drush_sm_command_list() {
  $commands = array();
  foreach (_drush_sm_services() as $service) {
    require_once dirname(__FILE__) . '/inc/' . $service . '.sm.inc';
    $option_set = call_user_func($service . '_sm_options');
    $argument_set= call_user_func($service . '_sm_arguments');
    
    foreach (_drush_sm_command() as $command) {
      $function = $service . '_sm_' . $command;
      if (function_exists($function)) {
        $options= $option_set[$command];
        $arguments = $argument_set[$command];
        $commands['sm ' . $command . ' ' . $service] = array(
         'callback' => $service . '_sm_' . $command,
         'description' => "$command from $service with " /* options: " . implode(' ', $options[$command]) . " and */ . "arguments: " . implode(' followed by ', $arguments),
        );
      }
    }
  }
  return $commands;
}
 
/**
 * 
// http://usr:pwd@www.test.com:81/dir/dir.2/index.htm?q1=value&q2=test#top
// @see http://stevenlevithan.com/demo/parseuri/cf/
 * @param uri
function drush_sm_create_db() {
  $args = func_get_args();
  $uri = $args[0];

  // parse_url()
  # $url = 'mysql://drush_mm:drush_mm@localhost/drush_mm';
  $HOSTNAME = 'test';

  $protocol = 'mysql';
  $user = $HOSTNAME;
  $password = $HOSTNAME;

  $host = 'localhost';
  $resource = $HOSTNAME;

  $template = "create database $resource; \n";
  $template.= "grant all on $resource.* to '$user'@'$host' identified by '$password'; \n";

  db_query( $template);
}
 */
